<?
/* =========================================================================
                                                == rpmod_recentlinks Hack ==
by Markku Seguerra
to display:  < ?php rpmod_recentlinks(); ? >
jS M Y @ g A == 22nd Mar 2004 @ 5 PM
M j == Mar 22
F j = March 22
========================================================================= */
function rpmod_recentlinks($limit = 12, $before = '<li>', $after = '</li>', $between = "\n", $date_append = 'F j')
{
    global $table_prefix, $wpdb;

    $tablerecentlinks = $table_prefix.'recentlinks';
    $a_tag = '[a]';
    $a_tag2 = '[/a]';
    $time_difference = get_settings('time_difference');

	if ('' != $limit) {
        $limit = (int) $limit;
		$limit = " LIMIT $limit";
	}

    $now = date('Y-m-d H:i:s',(time() + ($time_difference * 3600)));
    $sql = "SELECT ID, link_url, link_text, link_caption, link_rel, link_target, link_visible, date_added FROM $tablerecentlinks WHERE date_added < '$now' AND link_visible = 'Y' ORDER BY date_added DESC $limit";

    $links = $wpdb->get_results($sql);

    if ($links) {

        $out = '';
        foreach ($links as $link) {

            $link->link_text = stripslashes($link->link_text);
            $link->link_url = stripslashes($link->link_url);
            $link->link_caption = stripslashes($link->link_caption);
            $link->link_rel = stripslashes($link->link_rel);
            $link->link_target = stripslashes($link->link_target);

            $this_date = date($date_append, strtotime($link->date_added));

            if (strlen($link->link_caption) > 0) {
                $link->link_caption = str_replace($a_tag, '', strip_tags($link->link_text));
                $link->link_caption = str_replace($a_tag2, '', $link->link_caption);
                $link->link_caption = ' | '.$link->link_caption;
            } else {
                $link->link_caption = '';
            	
            }
            if (strlen($link->link_rel) == 0) {
                $rel = '';
            } else {
                $rel = ' rel="'.$link->link_rel.'"';
            }
            if (strlen($link->link_target) == 0) {
                $target = '';
            } else {
                $target = ' target="'.$link->link_target.'"';
            }

            if (  is_int(strpos($link->link_url, '&'))  &&  !strpos($link->link_url, '&amp;')  &&  !strpos($link->link_url, '&#038;')  ) {
                $link->link_url = str_replace('&', '&amp;', $link->link_url);
            }

            if (  is_int(strpos($link->link_text, $a_tag))  &&  is_int(strpos($link->link_text, $a_tag2))  ) {
                $pos_open = strpos($link->link_text, $a_tag);
                $pos_close = strpos($link->link_text, $a_tag2, $pos_open);

                $prefix = substr($link->link_text, 0, $pos_open);
                $suffix = substr($link->link_text, $pos_close + strlen($a_tag2));

                $middle = substr($link->link_text, $pos_open + strlen($a_tag), $pos_close - ($pos_open + strlen($a_tag)));

                $new_link = $prefix.'<a href="'.$link->link_url.'" title="'.wptexturize(date($date_append, strtotime($link->date_added)).$link->link_caption).'"'.$rel.$target.'>'.wptexturize($middle).'</a>'.$suffix;
            } else {
                $new_link = '<a href="'.$link->link_url.'" title="'.wptexturize(date($date_append, strtotime($link->date_added)).$link->link_caption).'"'.$rel.$target.'>'.wptexturize($link->link_text).'</a>';
            }

            $out .= $before.$new_link.$after.$between;

        }
    }
    echo $out;
}








/* =========================================================================
                                   == rpmod_recentlinks_archives_url Hack ==
by Markku Seguerra
to display:  < ?php rpmod_recentlinks_archives_url(); ? >
========================================================================= */
function rpmod_recentlinks_archives_url()
{
    $siteurl = get_settings('siteurl');
    $rewrite = get_settings('permalink_structure');

    if (strlen($rewrite) > 0) { // using mod_rewrite
    	echo $siteurl.'/recent-links/';
    } else {
    	echo $siteurl.'/wp-recent-links.php';
    }
}






/* =========================================================================
                                       == rpmod_recentlinks_rss2_url Hack ==
by Markku Seguerra
to display:  < ?php rpmod_recentlinks_rss2_url(); ? >
========================================================================= */
function rpmod_recentlinks_rss2_url()
{
    $siteurl = get_settings('siteurl');
    $rewrite = get_settings('permalink_structure');

    if (strlen($rewrite) > 0) { // using mod_rewrite
    	echo $siteurl.'/recent-links/feed/';
    } else {
    	echo $siteurl.'/wp-recent-links-rss2.php';
    }
}




/* =========================================================================
                                          == rpmod_recentlinks_month Hack ==
by Markku Seguerra
to display:  < ?php rpmod_recentlinks_month(); ? >
========================================================================= */
function rpmod_recentlinks_month($limit = '', $before = '<li>', $after = '</li>', $between = "\n", $show_link_count = false)
{
    global $table_prefix, $wpdb;
    $siteurl = get_settings('siteurl');
    $tablerecentlinks = $table_prefix.'recentlinks';
    $a_tag = '[a]';
    $a_tag2 = '[/a]';
    $time_difference = get_settings('time_difference');

    $y = $_REQUEST['y'];
    $m = $_REQUEST['m'];

	if ('' != $limit) {
        $limit = (int) $limit;
		$limit = " LIMIT $limit";
	}


	$now = date('Y-m-d H:i:s',(time() + ($time_difference * 3600)));

    $links = $wpdb->get_results("SELECT ID, link_url, link_text, link_caption, link_rel, link_target, link_visible, date_added FROM $tablerecentlinks WHERE date_added < '$now' AND link_visible = 'Y' AND YEAR(date_added) = '$y' AND MONTH(date_added) = '$m' ORDER BY date_added DESC" . $limit);

    if ($links) {

        $out = '';
        foreach ($links as $link) {

            $link->link_text = stripslashes($link->link_text);
            $link->link_url = stripslashes($link->link_url);
            $link->link_caption = stripslashes($link->link_caption);
            $link->link_rel = stripslashes($link->link_rel);
            $link->link_target = stripslashes($link->link_target);

            $this_date = date($date_append, strtotime($link->date_added));

            if (strlen($link->link_caption) == 0) {
                $link->link_caption = str_replace($a_tag, '', strip_tags($link->link_text));
                $link->link_caption = str_replace($a_tag2, '', $link->link_caption);
            }
            if (strlen($link->link_rel) == 0) {
                $rel = '';
            } else {
                $rel = ' rel="'.$link->link_rel.'"';
            }
            if (strlen($link->link_target) == 0) {
                $target = '';
            } else {
                $target = ' target="'.$link->link_target.'"';
            }

            if (  is_int(strpos($link->link_url, '&'))  &&  !strpos($link->link_url, '&amp;')  &&  !strpos($link->link_url, '&#038;')  ) {
                $link->link_url = str_replace('&', '&amp;', $link->link_url);
            }

            if (  is_int(strpos($link->link_text, $a_tag))  &&  is_int(strpos($link->link_text, $a_tag2))  ) {
                $pos_open = strpos($link->link_text, $a_tag);
                $pos_close = strpos($link->link_text, $a_tag2, $pos_open);

                $prefix = substr($link->link_text, 0, $pos_open);
                $suffix = substr($link->link_text, $pos_close + strlen($a_tag2));

                $middle = substr($link->link_text, $pos_open + strlen($a_tag), $pos_close - ($pos_open + strlen($a_tag)));

                $new_link = $prefix.'<a href="'.$link->link_url.'" title="'.wptexturize(date($date_append, strtotime($link->date_added)).' | '.$link->link_caption).'"'.$rel.$target.'>'.wptexturize($middle).'</a>'.$suffix;
            } else {
                $new_link = '<a href="'.$link->link_url.'" title="'.wptexturize(date($date_append, strtotime($link->date_added)).' | '.$link->link_caption).'"'.$rel.$target.'>'.wptexturize($link->link_text).'</a>';
            }

            $out .= $before.$new_link.$after.$between;

        }
    }
    echo $out;
}







/* =========================================================================
                                       == rpmod_recentlinks_archives Hack ==
by Markku Seguerra
to display:  < ?php rpmod_recentlinks_archives(); ? >
========================================================================= */
function rpmod_recentlinks_archives($limit = '', $before = '<li>', $after = '</li>', $between = "\n", $show_link_count = false)
{
    global $table_prefix, $wpdb;
    $siteurl = get_settings('siteurl');
    $tablerecentlinks = $table_prefix.'recentlinks';
    $time_difference = get_settings('time_difference');

    $rewrite = get_settings('permalink_structure');

	if ('' != $limit) {
        $limit = (int) $limit;
		$limit = " LIMIT $limit";
	}


	$now = date('Y-m-d H:i:s',(time() + ($time_difference * 3600)));

    $arcresults = $wpdb->get_results("SELECT DISTINCT YEAR(date_added) AS `year`, MONTH(date_added) AS `month`, count(ID) as links, date_added FROM $tablerecentlinks WHERE date_added < '$now' AND link_visible = 'Y' GROUP BY YEAR(date_added), MONTH(date_added) ORDER BY date_added DESC" . $limit);

    if ($arcresults) {
        $out = '';
        foreach ($arcresults as $month) {
            if (strlen($rewrite) > 0) {
            	$url = $siteurl.'/recent-links/'.date('Y/m/', strtotime($month->date_added));
            } else {
            	$url = $siteurl.'/wp-recent-links.php?y='.date('Y', strtotime($month->date_added)).'&amp;m='.date('m', strtotime($month->date_added));
            }

            if ($show_link_count) {
            	$link_count = ' ('.$month->links.')';
            } else {
            	$link_count = '';
            }

            $link = '<a href="'.$url.'" title="'.date('F Y', strtotime($month->date_added)).'">'.date('F Y', strtotime($month->date_added)).'</a>'. $link_count;
        	
            $out .= $before.$link.$after.$between;
        }
    	
    }
    echo $out;
}

?>